Attribute VB_Name = "Module1"
    Public Const pi = 3.14159265358979
    Public Const lg2db = 4.342944819 '10 / LN(10)  LN to dB conversion
    Public NumSamples As Long
    Public SampRate As Long
    
    Public windat(0 To 65536) As Single
    Sub FFT(dat() As Single)
    Dim wpr, wpi, wr, wi, tempr, tempi, wtemp As Double
    
    nn& = 2 * NumSamples
    j& = 1
    For i& = 1 To nn& Step 2
        If j& > i& Then
            temp = dat(i&)
            dat(i&) = dat(j&)
            dat(j&) = temp
            temp = dat(i& + 1)
            dat(i& + 1) = dat(j& + 1)
            dat(j& + 1) = temp
        End If
        m& = nn& \ 2
        While m& >= 2 And j& > m&
            j& = j& - m&
            m& = m& \ 2
        Wend
        j& = j& + m&
    Next i&
    mmax& = 2
 
    While nn& > mmax&
        istep& = 2 * mmax&
        theta = 2 * pi / mmax&
        wpr = Cos(theta)
        wpi = Sin(theta)
        wr = 1
        wi = 0
  
        For m& = 1 To mmax& Step 2
            For i& = m& To nn& Step istep&
                j& = i& + mmax&
                tempr = wr * dat(j&) - wi * dat(j& + 1)
                tempi = wr * dat(j& + 1) + wi * dat(j&)
                dat(j&) = dat(i&) - tempr
                dat(j& + 1) = dat(i& + 1) - tempi
                dat(i&) = dat(i&) + tempr
                dat(i& + 1) = dat(i& + 1) + tempi
            Next i&
            wtemp = wr
            wr = wr * wpr - wi * wpi
            wi = wi * wpr + wtemp * wpi
        Next m&
        mmax& = istep&
    Wend
End Sub
Sub HammingWind()
    For k& = 0 To NumSamples - 1
         windat(k&) = 0.54 - 0.46 * Cos(2 * pi * k& / NumSamples)
    Next k&
End Sub

Sub BlackHarrisWind()
    For k& = 0 To NumSamples - 1
        theta = 2 * pi * k& / NumSamples
        windat(k&) = (0.42323 - 0.49755 * Cos(theta) + 0.07922 * Cos(2 * theta))
    Next k&
End Sub

Sub HanningWind()
    For k& = 0 To NumSamples - 1
        windat(k&) = 0.5 - 0.5 * Cos(2 * pi * k& / NumSamples)
    Next k&
End Sub

Sub NoWind()
    For k& = 0 To NumSamples - 1
        windat(k&) = 0.5
    Next k&
End Sub
